<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Get_RefuelReport StructType
 * @subpackage Structs
 */
class Get_RefuelReport extends AbstractStructBase
{
    /**
     * The IncludePreviousRefuel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludePreviousRefuel;
    /**
     * The Login
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Login
     */
    public $Login;
    /**
     * The RefuelReportSelection
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RefuelReportSelection
     */
    public $RefuelReportSelection;
    /**
     * The FuelTypes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt
     */
    public $FuelTypes;
    /**
     * Constructor method for Get_RefuelReport
     * @uses Get_RefuelReport::setIncludePreviousRefuel()
     * @uses Get_RefuelReport::setLogin()
     * @uses Get_RefuelReport::setRefuelReportSelection()
     * @uses Get_RefuelReport::setFuelTypes()
     * @param bool $includePreviousRefuel
     * @param \StructType\Login $login
     * @param \StructType\RefuelReportSelection $refuelReportSelection
     * @param \ArrayType\ArrayOfInt $fuelTypes
     */
    public function __construct($includePreviousRefuel = null, \StructType\Login $login = null, \StructType\RefuelReportSelection $refuelReportSelection = null, \ArrayType\ArrayOfInt $fuelTypes = null)
    {
        $this
            ->setIncludePreviousRefuel($includePreviousRefuel)
            ->setLogin($login)
            ->setRefuelReportSelection($refuelReportSelection)
            ->setFuelTypes($fuelTypes);
    }
    /**
     * Get IncludePreviousRefuel value
     * @return bool
     */
    public function getIncludePreviousRefuel()
    {
        return $this->IncludePreviousRefuel;
    }
    /**
     * Set IncludePreviousRefuel value
     * @param bool $includePreviousRefuel
     * @return \StructType\Get_RefuelReport
     */
    public function setIncludePreviousRefuel($includePreviousRefuel = null)
    {
        // validation for constraint: boolean
        if (!is_null($includePreviousRefuel) && !is_bool($includePreviousRefuel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includePreviousRefuel, true), gettype($includePreviousRefuel)), __LINE__);
        }
        $this->IncludePreviousRefuel = $includePreviousRefuel;
        return $this;
    }
    /**
     * Get Login value
     * @return \StructType\Login|null
     */
    public function getLogin()
    {
        return $this->Login;
    }
    /**
     * Set Login value
     * @param \StructType\Login $login
     * @return \StructType\Get_RefuelReport
     */
    public function setLogin(\StructType\Login $login = null)
    {
        $this->Login = $login;
        return $this;
    }
    /**
     * Get RefuelReportSelection value
     * @return \StructType\RefuelReportSelection|null
     */
    public function getRefuelReportSelection()
    {
        return $this->RefuelReportSelection;
    }
    /**
     * Set RefuelReportSelection value
     * @param \StructType\RefuelReportSelection $refuelReportSelection
     * @return \StructType\Get_RefuelReport
     */
    public function setRefuelReportSelection(\StructType\RefuelReportSelection $refuelReportSelection = null)
    {
        $this->RefuelReportSelection = $refuelReportSelection;
        return $this;
    }
    /**
     * Get FuelTypes value
     * @return \ArrayType\ArrayOfInt|null
     */
    public function getFuelTypes()
    {
        return $this->FuelTypes;
    }
    /**
     * Set FuelTypes value
     * @param \ArrayType\ArrayOfInt $fuelTypes
     * @return \StructType\Get_RefuelReport
     */
    public function setFuelTypes(\ArrayType\ArrayOfInt $fuelTypes = null)
    {
        $this->FuelTypes = $fuelTypes;
        return $this;
    }
}
